#include <iostream>
#include <vector>
#include <random>
using namespace std;

int main() {
	random_device rnd_device;
	// Specify the engine and distribution
	mt19937 mersenne_engine {rnd_device()}; // Generates random integers
	uniform_int_distribution<int> dist {1, 100};
	auto gen = [&dist, &mersenne_engine] {
		return dist(mersenne_engine);
	};

	vector<int> v(10);
	generate(begin(v), end(v), gen);
	for(auto i : v) cout << i << " ";
	cout << endl;

	//	Count the number of even numbers in the vector by
	//	using the for_each function and a lambda.
	int evenCount = 0;
	for_each(v.begin(), v.end(), [&evenCount] (int n) {
		if ((n & 1) == 0) ++evenCount;
	});
	cout << "There are " << evenCount << " even numbers in the vector." << endl;

	evenCount = (int) count_if(v.begin(), v.end(),[] (int n) { return (n & 1) == 0; } );
	cout << "There are " << evenCount << " even numbers in the vector." << endl;

	// find the first even number
	auto result = find_if(v.begin(), v.end(), [](int n) { return (n & 1) == 0; });
	if (result != v.end()) {
		cout << "The first even number in the list is " << *result << "." << endl;
	} else {
		cout << "The list contains no even numbers." << endl;
	}
}

